package com.bonus.material.scrap.service;

import java.util.List;

import com.bonus.common.core.web.domain.AjaxResult;
import com.bonus.material.scrap.domain.ScrapApplyDetails;
import com.bonus.material.scrap.domain.vo.ScrapDetailsListVo;
import com.bonus.material.scrap.domain.vo.ScrapTaskListVo;
import com.bonus.material.scrap.domain.vo.ScrapTotalListVo;

/**
 * 报废任务详细Service接口
 * 
 * @author xsheng
 * @date 2024-10-16
 */
public interface IScrapApplyDetailsService {
    /**
     * 查询报废任务详细
     * 
     * @param id 报废任务详细主键
     * @return 报废任务详细
     */
    public ScrapApplyDetails selectScrapApplyDetailsById(Long id);

    /**
     * 查询报废任务详细列表
     * 
     * @param scrapApplyDetails 报废任务详细
     * @return 报废任务详细集合
     */
    List<ScrapTaskListVo> selectScrapApplyDetailsList(ScrapApplyDetails scrapApplyDetails);

    /**
     * 查询报废任务详细列表
     *
     * @param scrapApplyDetails 报废任务详细
     * @return 报废任务详细集合
     */
    List<ScrapApplyDetails> selectRepairQuestListByTaskId(ScrapApplyDetails scrapApplyDetails);


    /**
     * 新增报废任务详细
     * 
     * @param scrapApplyDetails 报废任务详细
     * @return 结果
     */
    public int insertScrapApplyDetails(ScrapApplyDetails scrapApplyDetails);

    /**
     * 修改报废任务详细
     * 
     * @param scrapApplyDetails 报废任务详细
     * @return 结果
     */
    public int updateScrapApplyDetails(ScrapApplyDetails scrapApplyDetails);

    /**
     * 批量删除报废任务详细
     * 
     * @param ids 需要删除的报废任务详细主键集合
     * @return 结果
     */
    public int deleteScrapApplyDetailsByIds(Long[] ids);

    /**
     * 删除报废任务详细信息
     * 
     * @param id 报废任务详细主键
     * @return 结果
     */
    public int deleteScrapApplyDetailsById(Long id);

    /**
     * 报废审核通过
     * @param scrapApplyDetails
     * @return
     */
    AjaxResult approve(ScrapApplyDetails scrapApplyDetails);

    /**
     * 报废审核驳回
     * @param scrapApplyDetails
     * @return
     */
    AjaxResult reject(ScrapApplyDetails scrapApplyDetails);

    /**
     * 查询报废台账任务列表
     * @param scrapApplyDetails
     * @return
     */
    List<ScrapTotalListVo> selectTotalScrapApplyDetailsList(ScrapApplyDetails scrapApplyDetails);

    /**
     * 报废台账审核通过
     * @param scrapApplyDetails
     * @return
     */
    AjaxResult ledgerApprove(ScrapApplyDetails scrapApplyDetails);

    /**
     * 报废台账审核驳回
     * @param scrapApplyDetails
     * @return
     */
    AjaxResult ledgerReject(ScrapApplyDetails scrapApplyDetails);

    /**
     * 查询报废台账审核总费用
     * @param scrapApplyDetails
     * @return
     */
    ScrapTotalListVo getTotalPrice(ScrapApplyDetails scrapApplyDetails);

    /**
     * 查询盘点报废任务列表
     * @param scrapApplyDetails
     * @return
     */
    List<ScrapTaskListVo> selectInventoryList(ScrapApplyDetails scrapApplyDetails);

    /**
     * 新增盘点报废
     * @param scrapApplyDetails
     * @return
     */
    AjaxResult savePutInfo(ScrapApplyDetails scrapApplyDetails);

    /**
     * 查询盘点报废任务详情
     * @param scrapApplyDetails
     * @return
     */
    ScrapApplyDetails getDetailsList(ScrapApplyDetails scrapApplyDetails);

    /**
     * 删除盘点报废
     * @param scrapApplyDetails
     * @return
     */
    AjaxResult delete(ScrapApplyDetails scrapApplyDetails);

    /**
     * 修改盘点报废
     * @param scrapApplyDetails
     * @return
     */
    AjaxResult updateList(ScrapApplyDetails scrapApplyDetails);

    /**
     * 盘点报废审核
     * @param scrapApplyDetails
     * @return
     */
    AjaxResult inventoryApprove(ScrapApplyDetails scrapApplyDetails);

    /**
     * 查询报废台账列表
     * @param scrapApplyDetails
     * @return
     */
    List<ScrapTotalListVo> getScrapList(ScrapApplyDetails scrapApplyDetails);

    /**
     * 查询报废台账明细列表
     * @param scrapApplyDetails
     * @return
     */
    List<ScrapDetailsListVo> getScrapDetailsList(ScrapApplyDetails scrapApplyDetails);
}
